<template>
  <v-container>
    <v-breadcrumbs class="px-0" :items="items"></v-breadcrumbs>

    <v-row no-gutters class="d-flex align-center">
      <h1>Novo Funcionário</h1>
      <v-spacer></v-spacer>
      <v-btn depressed small color="warning" to="/employees/">VOLTAR</v-btn>
    </v-row>
    <v-divider></v-divider>
    <div id="employees">
      <h2>Preencha o formulário:</h2>

      <v-form v-model="valid">
        <v-container>
          <v-row>
            <v-col cols="12" md="6">
              <v-text-field
                v-model="employee.name"
                :rules="nameRules"
                label="Nome completo"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field
                v-model="employee.phone"
                :rules="phoneRules"
                v-mask="maskPhone"
                label="Telefone"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="employee.email" :rules="emailRules" label="E-mail" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field
                v-model="employee.cpf"
                :rules="cpfRules"
                v-mask="maskCpf"
                label="CPF"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field
                v-model="employee.start_date"
                label="Data de inicio do contrato"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="employee.date_birth" label="Data de aniversário" required></v-text-field>
            </v-col>

            <v-col cols="12" md="12">
              <v-text-field v-model="employee.function" label="Função" required></v-text-field>
            </v-col>

            <v-col cols="12" md="2">
              <v-text-field v-model="employee.cep" label="CEP" required></v-text-field>
            </v-col>

            <v-col cols="12" md="4">
              <v-text-field v-model="employee.street" label="Rua" required></v-text-field>
            </v-col>

            <v-col cols="12" md="2">
              <v-text-field v-model="employee.number" label="Número" required></v-text-field>
            </v-col>

            <v-col cols="12" md="4">
              <v-text-field v-model="employee.neighborhood" label="Bairro" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="employee.city" label="Cidade" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="employee.state" label="Estado" required></v-text-field>
            </v-col>
          </v-row>
          <v-btn depressed color="success" @click="salvar">SALVAR</v-btn>
        </v-container>
      </v-form>
      <v-row>
        <v-spacer></v-spacer>
      </v-row>
    </div>
  </v-container>
</template>

<script>
import axios from "axios";
import { mask } from "vue-the-mask";
export default {
  directives: { mask },
  data: () => ({
    maskCpf: "###.###.###-##",
    maskPhone: "(##) ##### ####",
    valid: false,
    employee: {
      name: "",
      phone: "",
      cpf: "",
      start_date: "",
      date_birth: "",
      function: "",
      email: "",
      street: "",
      cep: "",
      number: "",
      city: "",
      state: "",
      neighborhood: ""
    },
    edit: false,
    cpfRules: [
      v => !!v || "CPF é obrigatório",
      v => v.length <= 15 || "CPF no mínimo 15 caracteres"
    ],
    nameRules: [v => !!v || "Nome é obrigatório"],
    emailRules: [
      v => !!v || "E-mail é obrigatório",
      v => /.+@.+/.test(v) || "E-mail inválido"
    ],
    phoneRules: [v => !!v || "Telefone é obrigatório"],
    items: [
      {
        text: "Dashboard",
        disabled: false,
        to: "/"
      },
      {
        text: "Funcionários",
        disabled: false,
        exact: true,
        to: "/employees"
      },
      {
        text: "Cadastrar funcionário",
        disabled: true
      }
    ]
  }),
  methods: {
    salvar() {
      if (this.edit == false) {
        console.log("salvar");
        console.log(this.employee);
        axios
          .post("https://young-forest-65938.herokuapp.com/api/v1/employees", {
            name: this.employee.name,
            phone: this.employee.phone,
            function: this.employee.function,
            email: this.employee.email,
            cpf: this.employee.cpf,
            start_date: this.employee.start_date,
            date_birth: this.employee.date_birth,
            street: this.employee.street,
            cep: this.employee.cep,
            number: this.employee.number,
            city: this.employee.city,
            state: this.employee.state,
            neighborhood: this.employee.neighborhood
          })
          .then(function(response) {
            console.log(this.employee);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/employees");
      } else {
        console.log("editar else");
        axios
          .put(
            `https://young-forest-65938.herokuapp.com/api/v1/employees/${this.$router.currentRoute.query.id}`,
            {
              name: this.employee.name,
              phone: this.employee.phone,
              function: this.employee.function,
              email: this.employee.email,
              cpf: this.employee.cpf,
              start_date: this.employee.start_date,
              date_birth: this.employee.date_birth,
              street: this.employee.street,
              cep: this.employee.cep,
              number: this.employee.number,
              city: this.employee.city,
              state: this.employee.state,
              neighborhood: this.employee.neighborhood
            }
          )
          .then(function(response) {
            console.log(this.employee);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/employees");
      }
    }
  },
  mounted() {
    console.log(this.$router.currentRoute.query.id);
    if (this.$router.currentRoute.query.id != null) {
      this.edit = true;
      console.log(this.$router.currentRoute.query.id);
      console.log("if mounted");
      return axios
        .get(
          `https://young-forest-65938.herokuapp.com/api/v1/employees/${this.$router.currentRoute.query.id}`
        )
        .then(response => {
          var resp = response.data;
          this.employee = resp.data;
          console.log(this.employee);
        });
    }
  }
};
</script>
